#include <Servo.h>
Servo servo;

#define INAL 22 // 22
#define INBL 23 // 23
#define ENL 24 // 24
#define PWML 12  // 12

#define INAR  47   // 47
#define INBR 48 // 48
#define ENR 46 // 46
#define PWMR 13 //13
const int chGo=3; //3 
const int chTurn=2; //1 
const int chServo=4;
unsigned long chGo1;
unsigned long chGoOld;
unsigned long chTurn1;
unsigned long chServo1;
int one;
int two;
int Signal;

int motorSpeedGo; //   
int motorSpeedTurn;
int ServoUpDown;
void setup() {
  Serial.begin(9600);
  servo.attach(0);
  pinMode(INAL, OUTPUT);
  pinMode(INBL, OUTPUT);
  pinMode(ENL, OUTPUT);
  pinMode(INAR, OUTPUT);
  pinMode(INBR, OUTPUT);
  pinMode(ENR, OUTPUT);
  pinMode(chGo, INPUT);
  pinMode(chTurn, INPUT);
  pinMode(chServo, INPUT);
  pinMode(A2, INPUT);
  pinMode(A1, INPUT);

  digitalWrite(ENL, HIGH);
  digitalWrite(ENR, HIGH);
}

void loop()
{

  
  chGo1 = pulseIn (chGo, HIGH);
  chTurn1 = pulseIn (chTurn,HIGH);
  chServo1 = pulseIn(chServo, HIGH);
  Serial.print("Servo ");
  Serial.println(chServo1);
  Serial.print("GO ");
  Serial.println(chGo1);
  Serial.print("Turn ");
  Serial.println(chTurn1);
  motorSpeedTurn= map(chTurn1, 1050, 1850, -120, 120);
  motorSpeedGo= map(chGo1, 1040, 1840, -120, 120);

  Serial.println(ServoUpDown);

    float p=0.001;
   one = analogRead(A2);
   two = analogRead(A1);

  if(one-two>80){
    digitalWrite(INAL, HIGH);      //     
    digitalWrite(INBL, LOW);
    analogWrite(PWML, 40);
    digitalWrite(INAR, LOW);      //     
    digitalWrite(INBR, HIGH);
    analogWrite(PWMR, 40);
  }
  if(two-one>80){
    digitalWrite(INAL, LOW);      //     
    digitalWrite(INBL, HIGH);
    analogWrite(PWML, 40);
    digitalWrite(INAR, HIGH);      //     
    digitalWrite(INBR, LOW);
    analogWrite(PWMR, 40);
  }
  else{
    digitalWrite(INAL, HIGH);      //     
    digitalWrite(INBL, LOW);
    analogWrite(PWML, 40);
    digitalWrite(INAR, HIGH);      //     
    digitalWrite(INBR, LOW);
    analogWrite(PWMR, 40);
  }

    motorSpeedTurn= map(chTurn1, 1050, 1850, -120, 120);
  motorSpeedGo= map(chGo1, 1040, 1840, -120, 120);
  if(motorSpeedTurn>30 && motorSpeedGo>=-30 && motorSpeedGo<=30){
    digitalWrite(INAL, LOW);      //     
    digitalWrite(INBL, HIGH);
    analogWrite(PWML, motorSpeedTurn);
    digitalWrite(INAR, HIGH);      //     
    digitalWrite(INBR, LOW);
    analogWrite(PWMR, motorSpeedTurn);

}
if(motorSpeedTurn<-30 && motorSpeedGo>=-30 && motorSpeedGo<=30){
  motorSpeedTurn=-motorSpeedTurn;
    digitalWrite(INAL, HIGH);      //     
    digitalWrite(INBL, LOW);
    analogWrite(PWML, motorSpeedTurn);
    digitalWrite(INAR, LOW);      //     
    digitalWrite(INBR, HIGH);
    analogWrite(PWMR, motorSpeedTurn);

}
if(motorSpeedGo>30 && motorSpeedTurn<=30 && motorSpeedTurn>=-30){
    digitalWrite(INAL, LOW);      //     
    digitalWrite(INBL, HIGH);
    analogWrite(PWML, motorSpeedGo);
    digitalWrite(INAR, LOW);      //     
    digitalWrite(INBR, HIGH);
    analogWrite(PWMR, motorSpeedGo);

}
if(motorSpeedGo<-30 && motorSpeedTurn<=30 && motorSpeedTurn>=-30){
  motorSpeedGo=-motorSpeedGo;

    digitalWrite(INAL, HIGH);      //     
    digitalWrite(INBL, LOW);
    analogWrite(PWML, motorSpeedGo);
    digitalWrite(INAR, HIGH);      //     
    digitalWrite(INBR, LOW);
    analogWrite(PWMR, motorSpeedGo);
}
if(motorSpeedGo>=-30 && motorSpeedGo<=30 && motorSpeedTurn<=30 && motorSpeedTurn>=-30){
    digitalWrite(INAL, HIGH);      //     
    digitalWrite(INBL, LOW);
    analogWrite(PWML, 0);
    digitalWrite(INAR, HIGH);      //     
    digitalWrite(INBR, LOW);
    analogWrite(PWMR, 0);
}



motorSpeedGo=0;
motorSpeedTurn=0;
  
  
}